<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: vector.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>vector.h</h1><a href="vector_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#ifndef _vector_H_ </span>
<a name="l00019"></a>00019 <span class="preprocessor"></span><span class="preprocessor">#define _vector_H_</span>
<a name="l00020"></a>00020 <span class="preprocessor"></span>
<a name="l00021"></a>00021 <span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00023"></a>00023 <span class="preprocessor">#endif</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="keywordtype">int</span> <a class="code" href="vector_8c.html#ae6b570a9b1d0273b6cad4dab66fd9c71">ConstraintSimplify</a>(Value *old, Value *<a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, <span class="keywordtype">int</span> len, Value* v);
<a name="l00026"></a>00026 Value* <a class="code" href="vector_8c.html#ae8b0745702c689f66f3d12bc17f93f58">value_alloc</a>(<span class="keywordtype">int</span> want, <span class="keywordtype">int</span> *got);
<a name="l00027"></a>00027 <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a3e050c3a0fbb40af2a15f874835e34a4">value_free</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, <span class="keywordtype">int</span> <a class="code" href="vector_8c.html#a439227feff9d7f55384e8780cfc2eb82">size</a>);
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a6926aa87c13e78aad894ed894ccf6ba7">Factorial</a>(<span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>,Value *result);
<a name="l00030"></a>00030 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#ae89968fb20e83ba8dc3e4ccb19d4eb3d">Binomial</a>(<span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>,<span class="keywordtype">int</span> <a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,Value *result);
<a name="l00031"></a>00031 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#ae13fd0bd2390d14102707a21128d0358">CNP</a>(<span class="keywordtype">int</span> a,<span class="keywordtype">int</span> b,Value *result);
<a name="l00032"></a>00032 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a465a286010ac5724a37644eff2922d76">Gcd</a>(Value a,Value b,Value *result);
<a name="l00033"></a>00033 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="vector_8c.html#ab719ec10095622cd0ad8024da53cdd4c">First_Non_Zero</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, <span class="keywordtype">unsigned</span> length);
<a name="l00034"></a>00034 <span class="keyword">extern</span> <a class="code" href="structVector.html">Vector</a> *<a class="code" href="vector_8c.html#a358c545236f58b1001479e4a69d318aa">Vector_Alloc</a>(<span class="keywordtype">unsigned</span> length);
<a name="l00035"></a>00035 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a055608d1a3726b7cb26e3e8074764ba0">Vector_Free</a>(<a class="code" href="structVector.html">Vector</a> *vector);
<a name="l00036"></a>00036 <span class="keyword">extern</span> <span class="keywordtype">void</span>  <a class="code" href="vector_8c.html#a1d9ab7791aa5fa2636c76f9d1c81349c">Vector_Print</a>(FILE *Dst, <span class="keyword">const</span> <span class="keywordtype">char</span> *Format, <a class="code" href="structVector.html">Vector</a> *Vec);
<a name="l00037"></a>00037 <span class="keyword">extern</span> <a class="code" href="structVector.html">Vector</a> *<a class="code" href="vector_8c.html#a419889434bd5beb853ddea6d3deff0b3">Vector_Read</a>(<span class="keywordtype">void</span>);
<a name="l00038"></a>00038 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a27ccb3ea01f3a496bb799fb99e9e3075">Vector_Set</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>,<span class="keywordtype">unsigned</span> length);
<a name="l00039"></a>00039 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a88f4d69371f16d6d28e8a87c496b0730">Vector_Exchange</a>(Value *p1, Value *p2, <span class="keywordtype">unsigned</span> length);
<a name="l00040"></a>00040 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(Value *p1, Value *p2, <span class="keywordtype">unsigned</span> length);
<a name="l00041"></a>00041 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a97b02f83ad0a070d3da9be9d0e908af6">Vector_Add</a>(Value *p1,Value *p2,Value *p3,<span class="keywordtype">unsigned</span> length);
<a name="l00042"></a>00042 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a9d092d406f74e17de0907853cfc90ab7">Vector_Sub</a>(Value *p1,Value *p2,Value *p3,<span class="keywordtype">unsigned</span> length);
<a name="l00043"></a>00043 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#aff5b0922db0c224d19a65a933a24ae5a">Vector_Or</a>(Value *p1,Value *p2,Value *p3,<span class="keywordtype">unsigned</span> length);
<a name="l00044"></a>00044 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a14c75456dab7e1b9296fb4ec7b6ad3a5">Vector_Scale</a>(Value *p1, Value *p2, Value lambda, <span class="keywordtype">unsigned</span>
<a name="l00045"></a>00045                          length);
<a name="l00046"></a>00046 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a95d6452a07b82054af71a14c686e66a8">Vector_AntiScale</a>(Value *p1,Value *p2,Value lambda,
<a name="l00047"></a>00047                                         <span class="keywordtype">unsigned</span> length);
<a name="l00048"></a>00048 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#ae572a02f9c8cd14b0ca8771c40dcaf75">Vector_Oppose</a>(Value *p1, Value *p2, <span class="keywordtype">unsigned</span> length);
<a name="l00049"></a>00049 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a29ab9dcdb0a2666d54c5698d5e3a802f">Inner_Product</a>(Value *p1,Value *p2,<span class="keywordtype">unsigned</span> length, Value *result);
<a name="l00050"></a>00050 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a4ff4221372f8458c26433046521d096d">Vector_Max</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length, Value *result);
<a name="l00051"></a>00051 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#af5a4710a73ea4aef5bfdc911997e44f2">Vector_Min</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length, Value *result);
<a name="l00052"></a>00052 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a4700bd41bb9179b23deb7ab9d80a463d">Vector_Combine</a>(Value *p1,Value *p2,Value *p3,Value
<a name="l00053"></a>00053                             lambda, Value mu, <span class="keywordtype">unsigned</span> length);
<a name="l00054"></a>00054 <span class="keyword">extern</span> <span class="keywordtype">int</span>  <a class="code" href="vector_8c.html#a29ed40e88da2f079a8fcd2b7b4c4dbeb">Vector_Equal</a>(Value *Vec1,Value *Vec2,<span class="keywordtype">unsigned</span> <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>);
<a name="l00055"></a>00055 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#aa27ec6b9fd1c1a6bf4a96bdb67c02619">Vector_Min_Not_Zero</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length,<span class="keywordtype">int</span> *index,Value
<a name="l00056"></a>00056                      *result);
<a name="l00057"></a>00057 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a801486b45cadc8b9d22d99a79af91fa1">Vector_Gcd</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length,Value *result);
<a name="l00058"></a>00058 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#ad423599c93d4db5d4d89ea716f590d47">Vector_Map</a>(Value *p1,Value *p2,Value *p3,<span class="keywordtype">unsigned</span>
<a name="l00059"></a>00059                        length, Value *(*f)(Value,Value));
<a name="l00060"></a>00060 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a9e3e9df020a7c7b0ad95baffed7ed5c9">Vector_Normalize</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length);
<a name="l00061"></a>00061 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a4095f8badebbf9903f88da363af136f8">Vector_Normalize_Positive</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">int</span> length,
<a name="l00062"></a>00062                                       <span class="keywordtype">int</span> pos);
<a name="l00063"></a>00063 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#a9d2676edc416e3d26a79ba431ac75fa2">Vector_Reduce</a>(Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>,<span class="keywordtype">unsigned</span> length,
<a name="l00064"></a>00064                   <span class="keywordtype">void</span>(*f)(Value,Value *),Value *result);
<a name="l00065"></a>00065 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="vector_8c.html#aaa8d4e874a24f79d91d1557fe4238655">Vector_Sort</a>(Value *vector,<span class="keywordtype">unsigned</span> <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>);
<a name="l00066"></a>00066 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="vector_8c.html#a4f5f43ecdfb5c63f8c3ecbf875887869">Vector_IsZero</a>(Value * v, <span class="keywordtype">unsigned</span> length);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>}
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="preprocessor">#endif </span><span class="comment">/* _vector_H_ */</span>
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
